#!/bin/sh

if [ -z "$SDLCONFIGBIN" ]; then
    export SDLCONFIGBIN=sdl-config
fi

#NOTE: The following has been tsted with an archive of SDL 1.2.15 ready for
#mingw32. It seems to work since we don't recompile the libraries for now...
if [ "$1" = "" ]; then
	echo
	echo "Usage:"
	echo "./crossbuild_mingw-w64.sh /path/to/SDL-mingw <Args for \"make\">"
	echo
	echo "Example:"
	echo "./crossbuild_mingw-w64.sh ~/dev/SDL-1.2.15 -j4"
	echo
	echo "Note that to use, for instance, SDL 2, you want something like this:"
	echo "SDLCONFIGBIN=sdl2-config ./crossbuild_mingw-w64.sh ~/dev/SDL-2.0 -j4"
	echo
else
	SDL_PATH=$1
	shift 1
	make BINPREFIX=i686-w64-mingw32- SDLCONFIG="$SDL_PATH/bin/$SDLCONFIGBIN --prefix=$SDL_PATH" PLATFORM=WINDOWS CXXFLAGS=-Iwindows/include "$@"
fi
